#![allow(deprecated)]
use std::fmt;
use std::str;
/// Aggregates duplicate timestamps on a single enum series. For aggregating across tag groupings, use
/// `EnumSeries.enumAggregation` with `aggregation.AggregationBuilder.groupBy`.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum EnumAggregationFunction {
    #[serde(rename = "MIN")]
    Min,
    #[serde(rename = "MAX")]
    Max,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl EnumAggregationFunction {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            EnumAggregationFunction::Min => "MIN",
            EnumAggregationFunction::Max => "MAX",
            EnumAggregationFunction::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for EnumAggregationFunction {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for EnumAggregationFunction {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for EnumAggregationFunction {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<EnumAggregationFunction, conjure_object::plain::ParseEnumError> {
        match v {
            "MIN" => Ok(EnumAggregationFunction::Min),
            "MAX" => Ok(EnumAggregationFunction::Max),
            v => v.parse().map(|v| EnumAggregationFunction::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for EnumAggregationFunction {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<EnumAggregationFunction, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the EnumAggregationFunction enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
